/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.name.dnd;

import org.eclipse.swt.dnd.DropTargetEffect;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.widgets.Control;

import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.IDropTargetable;
import eu.etaxonomy.taxeditor.preference.Resources;

/**
 * <p>NameEditorDropTargetEffect class.</p>
 *
 * @author n.hoffmann
 * @version $Id: $
 */
public class NameEditorDropTargetEffect extends DropTargetEffect {

	/**
	 * <p>Constructor for NameEditorDropTargetEffect.</p>
	 *
	 * @param control a {@link org.eclipse.swt.widgets.Control} object.
	 */
	public NameEditorDropTargetEffect(Control control) {
		super(control);
	}
	
	/** {@inheritDoc} */
	public void dragEnter(DropTargetEvent dropTargetEvent) {
		
		
		
		if(dropTargetEvent.widget instanceof IDropTargetable){
			((IDropTargetable) dropTargetEvent.widget).dragEntered();
		}
		
//		if(! EditorUtil.getActiveMultiPageTaxonEditor().equals(editor.getMultiPageTaxonEditor())){
//			editor.getMultiPageTaxonEditor().setFocus();
//		}
	}
	
	/** {@inheritDoc} */
	public void dragLeave(DropTargetEvent dropTargetEvent) {
		
		
		
		if(dropTargetEvent.widget instanceof Control){
			((Control) dropTargetEvent.widget).setBackground(EditorUtil.getColor(Resources.COLOR_COMPOSITE_BACKGROUND));
		}
	}
	
}
