package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import eu.etaxonomy.cdm.api.service.IOccurrenceService;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.store.CdmStore;

public class CreateFieldUnitHandler extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        if(AbstractUtility.getActivePart() instanceof DerivateView){
            DerivateView derivateView = (DerivateView)AbstractUtility.getActivePart();
            if(derivateView.isDirty()){
                MessagingUtils.warningDialog(DerivateView.VIEW_HAS_UNSAVED_CHANGES, this, DerivateView.YOU_NEED_TO_SAVE_BEFORE_PERFORMING_THIS_ACTION);
                return null;
            }
            FieldUnit fieldUnit = FieldUnit.NewInstance();
            fieldUnit = CdmBase.deproxy(CdmStore.getService(IOccurrenceService.class).save(fieldUnit), FieldUnit.class);
            derivateView.getConversationHolder().commit();
            derivateView.addHierarchy(fieldUnit);
            derivateView.refreshTree();
        }
        return null;
    }

}
